> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/vpc-network/deletesubnets.md).

# DeleteSubnets

## 1. API Description

This API (DeleteSubnets) is used to deletes one or more subnets.

{% hint style="info" %}
**Notes**

* Before deleting a subnet, clean up all resources under it, including network interfaces, instances, NAT gateways, HA VIPs, etc.
* The default subnet cannot be deleted.
* Batch deletion is supported. A failure to delete one subnet does not affect the others; failure details (subnet ID, error code, error message) are returned in the `failedSubnets` field of the response.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                       |
| -------------- | -------- | --------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| subnetIds      | Yes      | Array of String | <p>ID list of the subnets to be deleted.</p><p>It can be obtained by calling <a href="/api-reference/zec/vpc-network/describesubnets.md">DescribeSubnets</a>.</p> |

## 3. Output Parameters

| Parameter Name | Type                                                                                            | Description                                                                                                           |
| -------------- | ----------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| failedSubnets  | Array of [DeleteSubnetsFailedItem](/api-reference/zec/datastructure.md#deletesubnetsfaileditem) | <p>The list of details for subnets that failed to delete.</p><p>Empty if all subnets were deleted successfully.</p>   |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Batch delete subnets.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DeleteSubnets
<Common Request Params>

Request：
{
  "subnetIds": [
    "<subnetId1>",
    "<subnetId2>"
  ]
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "failedSubnets": [
      {
        "subnetId": "<subnetId1>",
        "errorCode": "INVALID_SUBNET_IN_USE",
        "errorMsg": "The specified subnet `<subnetId1>` is in use"
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                  | Description            |
| ---------------- | --------------------------- | ---------------------- |
| 404              | INVALID\_SUBNET\_NOT\_FOUND | Subnet does not exist. |
